osg::ConvexPlanarOccluder Class Reference

`#include <ConvexPlanarOccluder>`

Inheritance diagram for osg::ConvexPlanarOccluder:

## Public Types

typedef std::vector< ConvexPlanarPolygon > | HoleList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| ConvexPlanarOccluder ()
| ConvexPlanarOccluder (const ConvexPlanarOccluder &cpo, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Object (osg, ConvexPlanarOccluder)
void | setOccluder (const ConvexPlanarPolygon &cpp)
ConvexPlanarPolygon & | getOccluder ()
const ConvexPlanarPolygon & | getOccluder () const
void | addHole (const ConvexPlanarPolygon &cpp)
void | setHoleList (const HoleList &holeList)
HoleList & | getHoleList ()
const HoleList & | getHoleList () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

| ~ConvexPlanarOccluder ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

ConvexPlanarPolygon | _occluder
HoleList | _holeList
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

A class for representing convex clipping volumes made up of several ConvexPlanarPolygon.

## Member Typedef Documentation

## HoleList

typedef std::vector<ConvexPlanarPolygon> osg::ConvexPlanarOccluder::HoleList

## Constructor & Destructor Documentation

## ConvexPlanarOccluder() [1/2]

osg::ConvexPlanarOccluder::ConvexPlanarOccluder | ( |  | ) |

inline

References osg::Object::Object().

Referenced by ConvexPlanarOccluder(), and META_Object().

## ConvexPlanarOccluder() [2/2]

osg::ConvexPlanarOccluder::ConvexPlanarOccluder | ( | const ConvexPlanarOccluder & | cpo,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

inline

References _holeList, _occluder, ConvexPlanarOccluder(), osg::Object::Object(), and osg::CopyOp::SHALLOW_COPY.

## ~ConvexPlanarOccluder()

osg::ConvexPlanarOccluder::~ConvexPlanarOccluder | ( |  | ) |

protected

## Member Function Documentation

## addHole()

void osg::ConvexPlanarOccluder::addHole | ( | const ConvexPlanarPolygon & | cpp | ) |

inline

References _holeList.

## getHoleList() [1/2]

HoleList & osg::ConvexPlanarOccluder::getHoleList | ( |  | ) |

inline

References _holeList.

## getHoleList() [2/2]

const HoleList & osg::ConvexPlanarOccluder::getHoleList | ( |  | ) | const

inline

References _holeList.

## getOccluder() [1/2]

ConvexPlanarPolygon & osg::ConvexPlanarOccluder::getOccluder | ( |  | ) |

inline

References _occluder.

## getOccluder() [2/2]

const ConvexPlanarPolygon & osg::ConvexPlanarOccluder::getOccluder | ( |  | ) | const

inline

References _occluder.

## META_Object()

osg::ConvexPlanarOccluder::META_Object | ( | osg | ,
|  | ConvexPlanarOccluder | )

References ConvexPlanarOccluder().

## setHoleList()

void osg::ConvexPlanarOccluder::setHoleList | ( | const HoleList & | holeList | ) |

inline

References _holeList.

## setOccluder()

void osg::ConvexPlanarOccluder::setOccluder | ( | const ConvexPlanarPolygon & | cpp | ) |

inline

References _occluder.

## Member Data Documentation

## _holeList

HoleList osg::ConvexPlanarOccluder::_holeList

protected

Referenced by addHole(), ConvexPlanarOccluder(), getHoleList(), getHoleList(), and setHoleList().

## _occluder

ConvexPlanarPolygon osg::ConvexPlanarOccluder::_occluder

protected

Referenced by ConvexPlanarOccluder(), getOccluder(), getOccluder(), and setOccluder().

The documentation for this class was generated from the following file:

- ConvexPlanarOccluder